<?php
/** $Id: log.php 7228 2011-10-30 08:42:25Z machine $ **/
/**
* Fonctions de journalisation (log)  d'Ogspy
* @package OGSpy
* @subpackage main
* @author Kyser
* @copyright Copyright &copy; 2007, http://ogsteam.fr/
* @version 3.04b ($Rev: 7228 $)
* @modified $Date: 2011-10-30 09:42:25 +0100 (Sun, 30 Oct 2011) $
* @link $HeadURL: file:///home/ogsteam/svn/tags/ogspy-3.0.8/includes/log.php $
*/

if (!defined('IN_SPYOGAME')) {
	die("Hacking attempt");
}
global $ogspy_phperror;
$ogspy_phperror=Array();
/**
* Entre dans le journal d'une ligne d'information
* @param string $parameter type d'information
* @param mixed $option Donnes optionnelles
*/
function log_ ($parameter, $option=0) {
	global $db, $user_data, $server_config,$pub_action;

	$member = "Inconnu";
	if (isset($user_data)) {
		$member = $user_data["user_name"];
	}

	switch ($parameter) {
		/* ----------- Entre Journal gnrique de Mod ----------- */		
		case 'mod':
		$line = "[$pub_action] ".$member." ";
		if (is_array($option)) {
			$line .= print_r($option,true);
		}else {
			$line .= $option;
		}
		break;

		/* ----------- Administration ----------- */		
		case 'set_serverconfig' :
		$line = "[admin] ".$member." modifie les paramtres du serveur";
		break;
		
		case 'set_server_view' :
		$line = "[admin] ".$member." modifie les paramtres d'affichage du serveur";
		break;
    
		case 'set_db_size' :
		$line = "[admin] ".$member." modifie la taille de l'univers sa nouvelle taille est galaxy:".$server_config['num_of_galaxies']." et system:".$server_config['num_of_systems'];
		break;
		
		case 'mod_install' :
		$line = "[admin] ".$member." installe le mod \"".$option."\"";
		break;
		
		case 'mod_update' :
		$line = "[admin] ".$member." met  jour le mod \"".$option."\"";
		break;
		
		case 'mod_uninstall' :
		$line = "[admin] ".$member." dsinstalle le mod \"".$option."\"";
		break;
		
		case 'mod_active' :
		$line = "[admin] ".$member." active le mod \"".$option."\"";
		break;
		
		case 'mod_disable' :
		$line = "[admin] ".$member." dsactive le mod \"".$option."\"";
		break;
		
		case 'mod_order' :
		$line = "[admin] ".$member." repositionne le mod \"".$option."\"";
		break;

		case 'mod_normal' :
		$line = "[admin] ".$member." affiche le mod aux utilisateurs \"".$option."\"";
		break;

		case 'mod_admin' :
		$line = "[admin] ".$member." cache le mod aux utilisateurs \"".$option."\"";
		break;
        
        /* ----------- Erreur gestion mod ----------- */
        case 'mod_erreur_install_php' :
		$line = "[admin][mod_erreur] ".$member." fichier mod/".$option."/install.php introuvable ";
		break;
        
         case 'mod_erreur_install_txt' :
		$line = "[admin][mod_erreur] ".$member." fichier mod/".$option."/version.txt introuvable ";
		break;
        
       case 'mod_erreur_update' :
		$line = "[admin][mod_erreur] ".$member." fichier mod/".$option."/update.php introuvable ";
		break;
        
        case 'mod_erreur_minuscule' :
		$line = "[admin][mod_erreur] ".$member." dossier mod/".$option."/ n'est pas en minuscule ";
		break;
        
        case 'mod_erreur_install_bis' :
		$line = "[admin][mod_erreur] ".$member."  mod ".$option." dj install ";
		break;
        
        case 'mod_erreur_txt_warning' :
		$line = "[admin][mod_erreur] ".$member."  mod/".$option."/version.txt mal form ";
		break;
        
        
		/* ----------- Gestion systmes solaires et rapports ----------- */
		case 'load_system' :
		$line = $member." charge le systme solaire ".$option[0].":".$option[1];
		break;

		case 'load_system_OGS' :
		$line = $member." charge ".$option[0]." planetes via OGS : ".$option[1]." insertion(".$option[1]."), mise  jour(".$option[2]."), obsolte(".$option[3]."), chec(".$option[4].") - ".$option[5]." sec";
		break;

		case 'get_system_OGS' :
		if ($option != 0) $line = $member." rcupre les plantes de la galaxie ".$option;
		else $line = $member." rcupre toutes les plantes de l'univers";
		break;

		case 'load_spy' :
		$line = $member." charge ".$option." rapport(s) d'espionnage";
		break;

		case 'load_spy_OGS' :
		$line = $member." charge ".$option." rapport(s) d'espionnage via OGS";
		break;

		case 'export_spy_sector' :
		list($nb_spy, $galaxy, $system) = $option;
		$line = $member." rcupre ".$nb_spy." rapport(s) d'espionnage du systme [".$galaxy.":".$system."]";
		break;

		case 'export_spy_date' :
		list($nb_spy, $timestamp) = $option;
		$date = strftime("%d %b %Y %H:%M", $timestamp);
		$line = $member." rcupre ".$nb_spy." rapport(s) d'espionnage postrieur au ".$date;
		break;

		/* ----------- Gestion des erreurs ----------- */
		case 'mysql_error' :
		$line = 'Erreur critique mysql - Req : '.$option[0].' - Erreur n'.$option[1].' '.$option[2];
		$i=0;
		foreach ($option[3] as $l) {
			$line .= "\n";
			$line .= "\t".'['.$i.']'."\n";
			$line .= "\t\t".'file => '.$l['file']."\n";
			$line .= "\t\t".'ligne => '.$l['line']."\n";
			$line .= "\t\t".'fonction => '.$l['function'];
			$j=0;
			if (isset($l['args'])) {
				foreach ($l['args'] as $arg) {
					$line .= "\n";
					$line .= "\t\t\t".'['.$j.'] => '.$arg;
					$j++;

				}
			}
			$i++;
		}
		break;

		/* ----------- Gestion des membres ----------- */
		case 'login' :
		$line = $member. " se connecte";
		break;

		case 'login_ogs' :
		$line = $member." se connecte via OGS";
		break;

		case 'logout' :
		$line = $member." se dconnecte";
		break;

		case 'modify_account' :
		$line = $member." change son profil";
		break;

		case 'modify_account_admin' :
		$user_info = user_get($option);
		$line = "[admin] ".$member." change le profil de ".$user_info[0]['user_name'];
		break;

		case 'create_account' :
		$user_info = user_get($option);
		$line = "[admin] ".$member." cr le compte de ".$user_info[0]['user_name'];
		break;

		case 'regeneratepwd' :
		$user_info = user_get($option);
		$line = "[admin] ".$member." gnre un nouveau mot de passe pour ".$user_info[0]['user_name'];
		break;

		case 'delete_account' :
		$user_info = user_get($option);
		$line = "[admin] ".$member." supprime le compte de ".$user_info[0]['user_name'];
		break;

		case 'create_usergroup' :
		$line = "[admin] ".$member." cr le groupe ".$option;
		break;

		case 'modify_usergroup' :
		$usergroup_info = usergroup_get($option);
		$line = "[admin] ".$member." modifie les paramtres du groupe ".$usergroup_info["group_name"];
		break;

		case 'delete_usergroup' :
		$usergroup_info = usergroup_get($option);
		$line = "[admin] ".$member." supprime le groupe ".$usergroup_info["group_name"];
		break;

		case 'add_usergroup' :
		list($group_id, $user_id) = $option;
		$usergroup_info = usergroup_get($group_id);
		$user_info = user_get($user_id);
		$line = "[admin] ".$member." ajoute ".$user_info[0]["user_name"]." dans le groupe ".$usergroup_info["group_name"];;
		break;

		case 'del_usergroup' :
		list($group_id, $user_id) = $option;
		$usergroup_info = usergroup_get($group_id);
		$user_info = user_get($user_id);
		$line = "[admin] ".$member." supprime ".$user_info[0]["user_name"]." du groupe ".$usergroup_info["group_name"];;
		break;

		/* ----------- Classement ----------- */
		case 'load_rank' :
		list($support, $typerank, $typerank2, $timestamp, $countrank) = $option;
		switch ($support) {
			case "OGS": $support = "OGS";break;
			case "WEB": $support = "serveur web";break;
		}
		switch ($typerank) {
			case "general": $typerank = "gnral";break;
			case "fleet": $typerank = "flotte";break;
			case "research": $typerank = "recherche";break;
		}
		switch($typerank2) {
			case "player": $typerank2 = "joueur";
			case "ally": $typerank2 = "alliance";
		}
		$date = strftime("%d %b %Y %Hh", $timestamp);
		$line = $member." envoie le classement ".$typerank." ".$typerank2." du ".$date." via ".$support." [".$countrank." lignes]";
		break;

		case 'get_rank' :
		list($typerank, $timestamp) = $option;
		$date = strftime("%d %b %Y %H:%M", $timestamp);
		switch ($typerank) {
			case "points": $typerank = "gnral";break;
			case "flotte": $typerank = "flotte";break;
			case "research": $typerank = "recherche";break;
		}
		$line = $member." rcupre le classement ".$typerank." du ".$date;
		break;
        
        /* ----------- cache ----------- */
        case 'erreur_config_cache' :
		$line = $member." Impossible d crire sur le fichier donfig_cache. Vrifier les droits d acces au dossier  \'cache\' ";
		break;

	   case 'erreur_mod_cache' :
		$line = $member." Impossible d crire sur le fichier mod_cache. Vrifier les droits d acces au dossier  \'cache\' ";
		break;

		  /* ----------- cache ----------- */
       
	   case 'key' :
		$line = $member." Impossible de retrouver le fichier key.php. Vrifier les droits d acces au dossier  \'parameters\' ";
		break;

		/* ----------------------------------------- */

		case 'check_var' :
		$line = $member." envoie des donnes refuses par le contrleur : ".$option[0]." - ".$option[1];
		break;

		case 'debug' :
		$line = 'DEBUG : '.$option;
		break;
		case 'php_error' :
		$line = "[PHP-ERROR] ".$option[0]." - ".$option[1];
		if (isset($option[2])) $line .=" ; Fichier: ".$option[2];
		if (isset($option[3])) $line .=" ; Ligne: ".$option[3];

		break;

		default:
		$line = 'Erreur appel fichier log - '.$parameter.' - '.print_r($option);
		break;
	}
	
	$fichier = "log_".date("ymd").'.log';
	$line = "/*".date("d/m/Y H:i:s").'*/ '.$line;
	write_file(PATH_LOG_TODAY.$fichier, "a", $line);
}
/**
* Error handler PHP : log des erreurs PHP dans la journalisation d'OGSpy
* Optionnellement mise en place dans common.php , si $server_config["no_phperror"] n'est pas flagg  1
*/
function ogspy_error_handler($code, $message, $file, $line) {
	global $ogspy_phperror;
	$option=Array($code,$message,$file,$line);
	log_("php_error",Array($code,$message,$file,$line));
	global $user_data;
	if ($user_data["user_admin"]==1) {
		$line = "[PHP-ERROR] ".$option[0]." - ".$option[1];
		if (isset($option[2])) $line .=" ; Fichier: ".$option[2];
		if (isset($option[3])) $line .=" ; Ligne: ".$option[3];
	if ($option[0]!=8)	$ogspy_phperror[] = $line;
	}
}
